<?php

/**
 * @file
 * Theme related functions for the Chessboard Flexible module.
 */

function template_preprocess_chessboard_flexible(&$variables) {
  static $tables_xhtml = array();

  $image_directory_path = $variables['element']['#image_directory_path'];
  if (!isset($tables_xhtml[$image_directory_path])) {
    foreach($variables['element']['#table_tiles'] as $code => $tile) {
      $tables_xhtml[$image_directory_path][$code] = drupal_render($tile);
    }
  }
  $variables['table_xhtml'] = $tables_xhtml[$image_directory_path];
  // For convenience.
  $variables['file_max'] = $variables['element']['#board']->getBoardWidth();
  $variables['square_color_first'] = $variables['element']['#square_color_first'];
  $variables['border'] = $variables['element']['#border'];
  $board = array();
  $size = strlen($variables['element']['#board']->getValue());
  for ($i = 0; $i < $size; $i++) {
    $rank_d = (int) floor($i / $variables['file_max']);
    $file = $i - $rank_d * $variables['file_max'];
    if ($file == 0) {
      $board[$rank_d] = array();
    }
    $board[$rank_d][$file] = $variables['element']['#board']->getPieceCode($rank_d, $file);
  }
  $variables['board'] = $board;
}
